﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using KendoSandbox.Models;

namespace KendoSandbox.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Template()
        {
            ViewBag.Message = "Kendo Sandbox !";

            return View();
        }

        public ActionResult Index()
        {
            SettingsModel.Initialize();
            var model = new UserModel();
            return View(model);
        }

        [AcceptVerbs(HttpVerbs.Get | HttpVerbs.Post)]
        public JsonResult GetUserPowerPlants(Guid? id)
        {
            var selectList = SettingsModel.GetUserPvPlants(id).ToList();
            var ret = new JsonResult { Data = selectList, JsonRequestBehavior = JsonRequestBehavior.AllowGet };
            System.Threading.Thread.Sleep(3000);
            return ret;
        }

        [HttpPost]
        public ActionResult UpdatePlantSelection(Guid powerPlantId)
        {

            // Store the PowerPlantGuid in the session
            SettingsModel.PowerplantId = powerPlantId;
            System.Threading.Thread.Sleep(3000);
            // return an empty result since this is not processed.
            return null;
        }
 


        public ActionResult FetchInverterData([DataSourceRequest]DataSourceRequest request)
        {
            var model = new List<InverterModel> { 
                new InverterModel { InverterId = Guid.NewGuid(), Company = "Telerik", Url = "www.telerik.com" },
                new InverterModel { InverterId = Guid.NewGuid(), Company = "Microsoft"}, 
                new InverterModel { InverterId = Guid.NewGuid(), Company = "Localhost", Url = "196.168.0.1"}
            };

            DataSourceResult result = model.ToDataSourceResult(request);

            return Json(result);
        }

        [AcceptVerbs(HttpVerbs.Get | HttpVerbs.Post)]
        public ActionResult DeleteItem(Guid inverterId)
        {
            return Json(true, JsonRequestBehavior.AllowGet);
        }
    }
}
