﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace KendoSandbox.Models
{
    public static class SettingsModel
    {

        public static IDictionary<Guid, string> Customers { get; set; }

        public static IDictionary<Guid, string> PowerPlants { get; set; }

        public static Guid UserId { get; set; }

        public static Guid PowerplantId { get; set; }

        public static string Name { get; set; }

        public static string Language { get; set; }

        public static Guid SelectedCustomer
        {
            get { return UserId; }
            set { UserId = value; }
        }

        public static Guid SelectedPowerPlant
        {
            get { return PowerplantId; }
            set { PowerplantId = value; }
        }

        public static void Initialize()
        {
            // Initialize lists
            Customers = new Dictionary<Guid, string>
                {
                    {new Guid("C1557755-31F2-40B9-9228-0016B618E1AC"), "User1"},
                    {new Guid("C22704A6-A22D-4BD2-AEBE-53A0730FA222"), "User2"},
                    {new Guid("C3B887B4-327B-4345-BBF0-002759251431"), "User3"},
                };

            // Load customer list to be shown in the customer dropdown
            PowerPlants = GetUserPvPlants(UserId);
            //PowerplantId = Guid.Parse("D1A6B6A0-E07B-4D3F-90AE-002FB0AEFAAC");
            if (!PowerPlants.ContainsKey(PowerplantId))
            {
                // If no powerplant selected and the last selected powerplant is not in the list, assign the first element in the list.
                SelectedPowerPlant = PowerPlants.First().Key;
            }
            System.Threading.Thread.Sleep(1000);
        }

        public static IDictionary<Guid, string> GetUserPvPlants(Guid? id)
        {
            //var token = Token.Get();
            if(id.HasValue)
                UserId = id.Value;
            string customer = Customers[SelectedCustomer];

            if (SelectedCustomer == new Guid("C1557755-31F2-40B9-9228-0016B618E1AC"))
            {
                Language = "en";
            }
            if (SelectedCustomer == new Guid("C22704A6-A22D-4BD2-AEBE-53A0730FA222"))
            {
                Language = "de";
            }
            if (SelectedCustomer == new Guid("C3B887B4-327B-4345-BBF0-002759251431"))
            {
                Language = "fr";
            }

            var plants = new Dictionary<Guid, string>
                {
                    {new Guid("D1A6B6A0-E07B-4D3F-90AE-002FB0AEFAAC"), customer + ": PV Plant 1"},
                    {new Guid("D2DB676C-A56B-468F-993F-003F2AA135F4"), customer + ": PV Plant 2"},
                    {new Guid("D3F8EB0A-9030-4437-8B04-0040BE75434B"), customer + ": PV Plant 3"},
                };
            System.Threading.Thread.Sleep(1000);
            return plants;
        }


    }
}